package com.mins01.jwschat;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;


import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class Rooms {

	
	static final Logger logger = LogManager.getLogger(Server.class.getName());
	HashMap<String, Room> rooms = new HashMap<String, Room>();
	
	Server server;
	HashMap<String, User>users;
	
	public  Rooms(Server server) {
		this.server = server;
		this.users = server.users;
	}
	
	
	public Room createRoom(String roomName){
		if(isRoom(roomName)){
			logger.debug(roomName+" 라는 방이 이미존재합니다.");
			return null;
		}
		logger.debug(new Throwable().getStackTrace()[ 0 ].getMethodName()+":"+roomName);
		rooms.put(roomName,new Room(roomName,server));
		return getRoom(roomName);
	}
	public boolean isRoom(String roomName) {
		return rooms.containsKey(roomName);
	}
	public Room getRoom(String roomName) {
		if(!isRoom(roomName)){
			return null;
		}
		return rooms.get(roomName);
	}
	public List<String> getList() {
		List<String> list = new ArrayList<String>(rooms.keySet());
		Collections.sort(list);
		return list;
	}
	public void syncRoomlist(User usr) {
		ChatMsg cm = new ChatMsg();
		cm.put("cmd", "syncRoomlist");
		cm.put("data", getList());
		usr.sendCm(cm);
	}
}
